clc;
clear all;
%% 
s1 = 0.03;
s2 = 2-s1;
Vab = 240;
Vbc = 240;
Vca = 240;
Zs = 0.0774+0.1843i;
Zm = 4.8384i;
Zr = 0.0908+0.1843i;
%% 
RL1 = (1-s1)/s1*real(Zr);
RL2 = (1-s2)/s2*real(Zr);
ZM1 = Zs + Zm*(Zr+RL1)/(Zm+Zr+RL1);
YM1 = 1/ZM1;
ZM2 = Zs + Zm*(Zr+RL2)/(Zm+Zr+RL2);
YM2 = 1/ZM2;
YM012 = [1 0 0;0 YM1 0;0 0 YM2];
as = 1*exp(i*deg2rad(120));
As = [1 1 1; 1 as*as as;1 as as*as];
ts = 1/sqrt(3)*exp(i*deg2rad(30));
T = [1 0 0;0 conj(ts) 0; 0 0 ts];
YMabc = As*YM012*T*inv(As);
VLLabc = [Vab;Vbc*exp(-i*deg2rad(120));Vca*exp(i*deg2rad(120))];
IMabc = YMabc * VLLabc;
%VLNabc = [Vab/sqrt(3)*exp(-i*deg2rad(30));Vbc/sqrt(3)*exp(-i*deg2rad(150));Vca/sqrt(3)*exp(i*deg2rad(90))];
VLNabc = As*T*inv(As)*VLLabc;
S = VLNabc .* conj(IMabc);
IM012 = inv(As)*IMabc;
Ir012 = IM012.*[0;Zm/(Zm+Zr+RL1);Zm/(Zm+Zr+RL2)];
Irabc = As*Ir012;
%% 
disp('      RL1        RL2         ');
disp('      -----      -----       ');
fprintf('      %-11.4f %-11.4f \n', RL1,RL2);
ZM1
ZM2
YM1
YM2
YMabc
S
disp('      IMa        IMb         IMc         IM0         IM1         IM2         Ir1  ');
disp('      -----      -----       -----       -----       -----       -----       -----  ');
fprintf('ֵ %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f\n', abs(IMabc(1)),abs(IMabc(2)),abs(IMabc(3)),abs(IM012(1)),abs(IM012(2)),abs(IM012(3)),abs(Ir012(2)));
fprintf(' %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f\n', rad2deg(angle(IMabc(1))),rad2deg(angle(IMabc(2))),rad2deg(angle(IMabc(3))),rad2deg(angle(IM012(1))),rad2deg(angle(IM012(2))),rad2deg(angle(IM012(3))),rad2deg(angle(Ir012(2))));
disp('  ');

% disp('      VLNa       VLNb        VLNc    ');
% disp('      -----      -----       -----  ');
% fprintf('ֵ %-11.4f %-11.4f %-11.4f\n', abs(VLNabc(1)),abs(VLNabc(2)),abs(VLNabc(3)));
% fprintf(' %-11.4f %-11.4f %-11.4f\n', rad2deg(angle(VLNabc(1))),rad2deg(angle(VLNabc(2))),rad2deg(angle(VLNabc(3))));
% disp('  ');

disp('      Ira        Irb         Irc    ');
disp('      -----      -----       -----  ');
fprintf('ֵ %-11.4f %-11.4f %-11.4f\n', abs(Irabc(1)),abs(Irabc(2)),abs(Irabc(3)));
fprintf(' %-11.4f %-11.4f %-11.4f\n', rad2deg(angle(Irabc(1))),rad2deg(angle(Irabc(2))),rad2deg(angle(Irabc(3))));

%% Ṧ
P=real(Ir012(2)*Ir012(2)*RL1+Ir012(3)*Ir012(3)*RL2)
