clc;
clear all;
%% (1)
syms x y;
eqns = [230*sin(x)+250*sin(y)==0 , 240+230*cos(x)+250*cos(y)==0];
vars=[x,y];
[x,y]=solve(eqns,vars);
Bdeg = vpa(rad2deg(x));
B = min(double(Bdeg));
Cdeg = vpa(rad2deg(y));
C = max(double(Cdeg));
%% 
s1 = 0.03;
s2 = 2-s1;
Vab=240;
Vbc=230;
Vca=250;
Zs = 0.0774+0.1843i;
Zm = 4.8384i;
Zr = 0.0908+0.1843i;
%% 
RL1 = (1-s1)/s1*real(Zr);
RL2 = (1-s2)/s2*real(Zr);
ZM1 = Zs + Zm*(Zr+RL1)/(Zm+Zr+RL1);
YM1 = 1/ZM1;
ZM2 = Zs + Zm*(Zr+RL2)/(Zm+Zr+RL2);
YM2 = 1/ZM2;
YM012 = [1 0 0;0 YM1 0;0 0 YM2];
as = 1*exp(i*deg2rad(120));
As = [1 1 1; 1 as*as as;1 as as*as];
ts = 1/sqrt(3)*exp(i*deg2rad(30));
T = [1 0 0;0 conj(ts) 0; 0 0 ts];
YMabc = As*YM012*T*inv(As);
VLLabc = [Vab;Vbc*exp(i*deg2rad(B));Vca*exp(i*deg2rad(C))];
IMabc = YMabc*VLLabc;
% VLNabc = [Vab/sqrt(3)*exp(-i*deg2rad(30));Vbc/sqrt(3)*exp(i*deg2rad(B-30));Vca/sqrt(3)*exp(i*deg2rad(C-30))];
VLNabc = As*T*inv(As)*VLLabc;
S = VLNabc .* conj(IMabc);
IM012 = inv(As)*IMabc;
Ir012 = IM012.*[0;Zm/(Zm+Zr+RL1);Zm/(Zm+Zr+RL2)];
Irabc = As*Ir012;
%% 
disp('      Bdeg         Cdeg              RL1        RL2         ');
disp('      -----        -----             -----      -----       ');
fprintf('      %-11.4f %-11.4f       %-11.4f %-11.4f \n', B,C,RL1,RL2);
ZM1
ZM2
YM1
YM2
YMabc
S
disp('      IMa        IMb         IMc         IM0         IM1         IM2         Ir1         Ir2  ');
disp('      -----      -----       -----       -----       -----       -----       -----       -----  ');
fprintf('ֵ %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f\n', abs(IMabc(1)),abs(IMabc(2)),abs(IMabc(3)),abs(IM012(1)),abs(IM012(2)),abs(IM012(3)),abs(Ir012(2)),abs(Ir012(3)));
fprintf(' %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f %-11.4f\n', rad2deg(angle(IMabc(1))),rad2deg(angle(IMabc(2))),rad2deg(angle(IMabc(3))),rad2deg(angle(IM012(1))),rad2deg(angle(IM012(2))),rad2deg(angle(IM012(3))),rad2deg(angle(Ir012(2))),rad2deg(angle(Ir012(3))));
disp('  ');

disp('      VLLa       VLLb        VLLc    ');
disp('      -----      -----       -----  ');
fprintf('ֵ %-11.4f %-11.4f %-11.4f\n', abs(VLLabc(1)),abs(VLLabc(2)),abs(VLLabc(3)));
fprintf(' %-11.4f %-11.4f %-11.4f\n', rad2deg(angle(VLLabc(1))),rad2deg(angle(VLLabc(2))),rad2deg(angle(VLLabc(3))));
disp('  ');

disp('      Ira        Irb         Irc    ');
disp('      -----      -----       -----  ');
fprintf('ֵ %-11.4f %-11.4f %-11.4f\n', abs(Irabc(1)),abs(Irabc(2)),abs(Irabc(3)));
fprintf(' %-11.4f %-11.4f %-11.4f\n', rad2deg(angle(Irabc(1))),rad2deg(angle(Irabc(2))),rad2deg(angle(Irabc(3))));

%% Ṧ
P=real(Ir012(2)*Ir012(2)*RL1+Ir012(3)*Ir012(3)*RL2)